package com.ozs.web.core.util;

import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

@Slf4j
@Component
public class TestCameraUtil {


    public void test() {
        Process exec = null;
        try {
            exec = Runtime.getRuntime().exec(new String[]{"sh", "-c", "/usr/local/ffmpeg/bin/ffmpeg -f concat -safe 0 -i /opt/streams/record/flv/42010001541320001116/85e3a21d-88f1-453e-a38e-3a6097ae81f8.txt -c copy /data/service/hazard-admin/uploadPath/flv/2023-04-03/42010001541320001116/85e3a21d-88f1-453e-a38e-3a6097ae81f8.flv"});
        } catch (IOException e) {
            log.error(e.getMessage());
            e.printStackTrace();
        }
        try {
            printProcessMsg(exec);
        } catch (IOException e) {
            log.error(e.getMessage());
            e.printStackTrace();
        }
        try {
            int i = exec.waitFor();
        } catch (InterruptedException e) {
            log.error(e.getMessage());
            e.printStackTrace();
        }
    }


    /**
     * 处理process输出流和错误流，防止进程阻塞，在process.waitFor();前调用
     *
     * @param exec
     * @throws IOException
     */
    private void printProcessMsg(Process exec) throws IOException {
        //防止ffmpeg进程塞满缓存造成死锁
        InputStream error = exec.getErrorStream();
        InputStream is = exec.getInputStream();

        StringBuffer result = new StringBuffer();
        String line = null;
        try {
            BufferedReader br = new BufferedReader(new InputStreamReader(error, "GBK"));
            BufferedReader br2 = new BufferedReader(new InputStreamReader(is, "GBK"));

            while ((line = br.readLine()) != null) {
                result.append(line + "\n");
            }
            log.info("FFMPEG视频转换进程错误信息：" + result.toString());

            result = new StringBuffer();
            line = null;

            while ((line = br2.readLine()) != null) {
                result.append(line + "\n");
            }
            log.info("FFMPEG视频转换进程输出内容为：" + result.toString());
        } catch (IOException e2) {
            e2.printStackTrace();
        } finally {
            error.close();
            is.close();
        }

    }

}
